module purge
unset LD_LIBRARY_PATH
unset OIFS_LAPACK_LIB


module load intel/2018.4
module load impi/2018.4
module load mkl/2018.4
module load cmake/3.23.2
module load netcdf/4.4.1.1
module load python/3.6.1
module load eccodes/2.8.0
module load hdf5/1.8.19

export CXX=mpiicc
export FC=mpiifort
export C=mpiicc

# Open IFS settings
export OIFS_TOPLEVEL_DIR=$HOME/awi-cm3/awicm3-v3.1/oifs-43r3
export OIFS_COMP=intel-opt_mn4

export OIFS_XIOS=enable
export OIFS_XIOS_DIR=$HOME/awi-cm3/awicm3-v3.1/xios
export OIFS_XIOS_LIB="-L$OIFS_XIOS_DIR/lib -lxios -lstdc++"


export NETCDFROOT=/apps/NETCDF/4.4.1.1/INTEL/IMPI
export OIFS_NETCDF_INCLUDE="-I$NETCDFROOT/include"
export OIFS_NETCDF_LIB="-L$NETCDFROOT/lib -lnetcdf"
export OIFS_NETCDFF_INCLUDE=-I$NETCDFROOT/include/
export OIFS_NETCDFF_LIB="-L$NETCDFROOT/lib -lnetcdff"

export OIFS_OASIS_BASE=$HOME/awi-cm3/awicm3-v3.1/oasis
export OIFS_OASIS_INCLUDE=-I/home/bsc32/bsc32044/awi-cm3/awicm3-v3.1/oasis/include
export OIFS_OASIS_LIB="-L$HOME/awi-cm3/awicm3-v3.1/oasis/build/lib/psmile -L$OIFS_OASIS_BASE/build/lib/psmile/scrip -L$OIFS_OASIS_BASE/build/lib/psmile/mct -L$OIFS_OASIS_BASE/build/lib/psmile/mct/mpeu -lpsmile -lmct -lmpeu -lscrip"


cd oifs-43r3
cd make ; mkdir -p esm/oifs/bin ;../fcm/bin/fcm make -v -j8 -f oifs.fcm ; mv $OIFS_COMP/oifs/bin/master.exe esm/oifs/bin/oifs
cd ..
